<?php

/**
 * Формирование блоков компонента Publicator
 * @var $b array содержимое блоков
 * @var $extra array доп. параметры
 */

use bff\db\Publicator;

if( ! empty($b))
{
   $imgAlt = ( isset($extra['title_alt']) ? $extra['title_alt'].' ' : '')._t('','фото').' '; $j = 2;
   $bPrint = $this->input->get('print', TYPE_BOOL);
   $videoWidth = $this->sett['video_width'];
   $videoHeight = $this->sett['video_height'];
   $galleryIndex = 1;
   $photosZoom = 0;
   foreach($b as $k=>$v)
   {
       if($bPrint) { 
           if(!in_array($v['type'], array(Publicator::blockTypeText, Publicator::blockTypeQuote))) {
                continue;
           }
       }
       switch ($v['type'])
       {
           case Publicator::blockTypeText:
           {
                ?><div class="txt-txt"><?= (isset($v['text'][LNG]) ? $v['text'][LNG] : ''); ?></div><?
           } break;
           case Publicator::blockTypeSubtitle:
           {
                $size = 'h'.$v['size'];
                ?><div class="txt-subtitle"><<?= $size ?>><?= (isset($v['text'][LNG]) ? $v['text'][LNG] : ''); ?></<?= $size ?>></div><?
           } break;
           case Publicator::blockTypeQuote:
           {
                ?><div class="txt-quote"><?= (isset($v['text'][LNG]) ? $v['text'][LNG] : ''); ?></div><?
           } break;
           case Publicator::blockTypePhoto:
           {
                $view = explode(';', $v['view']);
                $zoom = !empty($v['zoom']); if($zoom) $photosZoom++;
                $alt  = ( ! empty($v['alt'][LNG]) ? $v['alt'][LNG] : $imgAlt.$j++ );
                ?><div class="txt-img<? if( $zoom ){ ?> img-link<? } ?>" style="width: <?= $view[0]; ?>px;">
                    <? if( $zoom ){ ?><a href="<?= $v['url'][Publicator::szZoom] ?>" class="fancyzoom"><img src="<?= $v['url'][Publicator::szView]; ?>" alt="<?= $alt ?>" /></a><? } else { ?><img src="<?= $v['url'][Publicator::szView]; ?>" alt="<?= $alt ?>" /><? } ?>
                    <span><?= (isset($v['text'][LNG]) ? $v['text'][LNG] : ''); ?></span>
               </div><?
           } break;
           case Publicator::blockTypeGallery:
           {
                $rel = 0;
                ?><div class="imageGallery" id="imageGallery<?= $galleryIndex ?>">
                    <div class="image">
                        <ul><? foreach($v['p'] as $gp) { ?><li><img src="<?= $gp['url'][Publicator::szView]; ?>" alt="<?= ( ! empty($gp['alt'][LNG]) ? $gp['alt'][LNG] : $imgAlt.$j++ ) ?>" /></li><? } ?></ul>
                    </div>
                    <div class="description">
                        <ul><? foreach($v['p'] as $gp) { ?><li><?= ($gp['text'][LNG]!='' ? $gp['text'][LNG] : '&nbsp;'); ?></li><? } ?></ul>
                    </div>
                    <div class="navigation">
                        <div class="inactive"></div>
                        <div class="active"></div>
                        <ul><li class="left"></li><? $rel = 0; foreach($v['p'] as $gp) { ?><li><span rel="<?= $rel++; ?>"></span></li><? } ?><li class="right"></li></ul>
                    </div>
                    <span class="play"></span>
                  </div>
                  <script type="text/javascript"><? js::start(); ?> bffGalleryInline.init('#imageGallery<?= $galleryIndex ?>'); <? js::stop(); ?></script>
                <?
                $galleryIndex++;
           } break;
           case Publicator::blockTypeVideo:
           {
                if($v['source'] == 'vk') {
                  ?><div class="txt-video"><iframe src="<?= $v['video']; ?>" width="<?= $videoWidth; ?>" height="<?= $videoHeight; ?>" frameborder="0"></iframe></div><?
                } else {
                ?><div class="txt-video txt-video-in-content">
                    <object width="<?= $videoWidth; ?>" height="<?= $videoHeight; ?>">
                        <param name="allowfullscreen" value="true" />
                        <param name="allowscriptaccess" value="always" />
                        <param name="wmode" value="transparent" />
                        <param name="movie" value="<?= $v['video']; ?>" />
                        <embed src="<?= $v['video']; ?>" type="application/x-shockwave-flash" allowfullscreen="true" allowscriptaccess="always" wmode="transparent" width="<?= $videoWidth; ?>" height="<?= $videoHeight; ?>"></embed>
                    </object>
                  </div><?
                }
           } break;
       }
   }
}