<?php
    /**
     * Всплывающее окно активации услуг (продвижение ОБ)
     * @var $this Auto
     */
    if( ! bff::servicesEnabled()) return;
    $svc = Svc::model()->svcListing(Svc::TYPE_SERVICE, $this->module_name);
    $psystems = Bills::getPaySystems(false);
    $currency = Site::currencyDefault();
    $balance  = User::balance();

    $paySystemsBlock = function($nSvcPrice) use ($balance, $psystems)
    {
        if ($balance >= $nSvcPrice || empty($psystems)) {
            return;
        }

        reset($psystems);
        ?><input type="hidden" name="ps" value="<?= key($psystems); ?>" /><?

        if (sizeof($psystems) > 1) {
            ?>
            <div class="pay-systems mb15">
                <? $i = 0; foreach($psystems as $k=>$v) { ?>
                <div class="item<? if(!$i++){ ?> active<? } ?> <?= $v['class'] ?>" data-ps="<?= HTML::escape($k) ?>">
                    <div class="text"><a href="javascript:void(0);"><?= $v['title'] ?></a></div>
                </div>
                <? } ?>
                <div class="clear"></div>
            </div>
            <?
        }
    };
?>
<script type="text/javascript">
<? js::start(); ?>
var jAutoItemsPromote = (function(){
    var $popup = false, popup, $blocks, $links, processing = false,
        params = {id: 0, hash:''}, itemState = {};

    $(function(){
        popup = app.popup('auto-promote', '#popup-auto-promote', false, {onInit: function($p){}, scroll:true});
        $popup = popup.getPopup();
        $blocks = $popup.find('.bp-block');
        $links = $popup.find('.bp-block-link');
        $popup.on('click', '.pay-systems .item', function(e){
            nothing(e);
            var $form = $(this).closest('form');
            $form.find('[name="ps"]').val( $(this).data('ps') );
            $(this).addClass('active').siblings().removeClass('active');
        });
        params.hash = app.csrf_nonce;
    });

    return {
        promote: function(id, preview, e)
        {
            if( ! itemState.hasOwnProperty(id) ) {
                bff.ajax('<?= bff::urlAjax('auto','item-promote-data') ?>', {item_id:id,hash:app.csrf_nonce}, function(data, errors){
                    if(data && data.success) {
                        itemState[id] = data;
                        jAutoItemsPromote.promote(id, preview, e);
                    }
                });
                return;
            }

            $('#auto-promote-id', $popup).val(id);
            if( preview ) {
                $('#auto-promote-itempreview', $popup).html(preview);
            }
            var state = itemState[id];
            var $marked = $popup.find('.marked-state').hide();
            if( intval(state.marked) > 0 ) {
                $marked.html(state.marked_to).show();
            }
            var $fixed = $popup.find('.fixed-state').hide();
            if( intval(state.fixed) > 0 ) {
                $fixed.html(state.fixed_to).show();
            }
            var $vip = $popup.find('.vip-state').hide();
            if( intval(state.vip) > 0 ) {
                $vip.html(state.vip_to).show();
            }
            params.id = id;
            popup.show(e);
        },
        selectBlock: function(link)
        {
            link = $(link);
            var $b = link.parent().next();
            $blocks.addClass('displaynone').filter($b).removeClass('displaynone');
            $links.removeClass('active').addClass('ajax');
            link.toggleClass('active ajax');
            $b.find('.error:first').hide();
            return false;
        },
        submit: function(btn)
        {
            if(processing) return;

            var $form = $(btn.form); btn = $(btn);
            var $err = $form.find('.error:first');
            bff.ajax('<?= bff::urlAjax('auto','item-promote') ?>', $form.serialize()+'&'+$.param(params), function(data, errors){
                if(data && data.success) {
                    if( data.hasOwnProperty('form') ) {
                        app.pay(data.form);
                    } else if( data.hasOwnProperty('redirect') ) {
                        bff.redirect(data.redirect);
                    } else {
                        location.reload();
                    }
                } else {
                    app.showError($err, errors);
                }
            }, function(p) {
                processing = p;
                if(p) btn.prop('disabled', true).val('<?= _t('', 'подождите...'); ?>');
                else  btn.prop('disabled', false).val('<?= _t('', 'оплатить'); ?>');
            });
        }
    };
}());
<? js::stop(); ?>
</script>

<div class="popup displaynone" id="popup-auto-promote" style="width: 650px; margin-left: -270px; top:-150px;">
    <div class="popup-title"><?= _t('', 'Продвинуть объявление:'); ?></div>
    <div class="close"><span>x</span> <a href="#" class="close"><?= _t('', 'закрыть'); ?></a></div>
    <div class="content-popup" style="margin-top: 5px;">

    <div id="auto-promote-itempreview" class="estate-other" style="margin-left: 35px;"></div>

    <div class="form-box" id="svc-promote-block" style="padding-left: 35px;">
        <? /* Поднятие */ ?>
        <? if( ! empty($svc['up']) && ! empty($svc['up']['on']) ) { $s =& $svc['up']; ?>
        <h3><a class="active bp-block-link" href="#" onclick="return jAutoItemsPromote.selectBlock(this);"><?= _t('', 'Поднять объявление'); ?></a></h3>
        <div class="bp-block">
            <form>
                <input type="hidden" name="svc" value="<?= Auto::SERVICE_UP ?>" />
                <div class="error mb15" style="display: none;"></div>
                <div class="mb15"><?= $s['description'][LNG] ?></div>
                <? $paySystemsBlock($s['price']); ?>
                <div class="mb15">
                    <?= _t('', 'Стоимость: <b>[price]</b>', array('price'=>$s['price'].' '.$currency)); ?>
                </div>
                <div class="btn mr10 mb10 left"><input type="button" onclick="jAutoItemsPromote.submit(this);" value="<?= _t('', 'Оплатить'); ?>" /><i></i></div>
                <div class="clear"></div>
            </form>
            <div class="separator"></div>
        </div>
        <? } ?>

        <? /* Выделение */ ?>
        <? if( ! empty($svc['mark']) && ! empty($svc['mark']['on']) ) { $s =& $svc['mark']; ?>
        <h3><a class="ajax bp-block-link" href="#" onclick="return jAutoItemsPromote.selectBlock(this);"><?= _t('', 'Выделить объявление'); ?></a></h3>
        <div class="bp-block displaynone">
            <form>
                <input type="hidden" name="svc" value="<?= Auto::SERVICE_MARK ?>" />
                <div class="error mb15" style="display: none;"></div>
                <div class="mb15"><?= $s['description'][LNG] ?></div>
                <? $paySystemsBlock($s['price']); ?>
                <div class="mb15">
                    <?= _t('', 'Стоимость: <b>[price]</b>', array('price'=>$s['price'].' '.$currency)); ?>
                </div>
                <div class="marked-state mb15" style="display: none;"></div>
                <div class="btn mr10 mb10 left"><input type="button" onclick="jAutoItemsPromote.submit(this);" value="<?= _t('', 'Оплатить'); ?>" /><i></i></div>
                <div class="clear"></div>
            </form>
            <div class="separator"></div>
        </div>
        <? } ?>

        <? /* Закрепление */ ?>
        <? if( ! empty($svc['fix']) && ! empty($svc['fix']['on']) ) { $s =& $svc['fix']; ?>
        <h3><a class="ajax bp-block-link" href="#" onclick="return jAutoItemsPromote.selectBlock(this);"><?= _t('', 'Закрепить объявление'); ?></a></h3>
        <div class="bp-block displaynone">
            <form>
                <input type="hidden" name="svc" value="<?= Auto::SERVICE_FIX ?>" />
                <div class="error mb15" style="display: none;"></div>
                <div class="mb15"><?= $s['description'][LNG] ?></div>
                <? $paySystemsBlock($s['price']); ?>
                <div class="mb15">
                    <?= _t('', 'Стоимость: <b>[price]</b>', array('price'=>$s['price'].' '.$currency)); ?>
                </div>
                <div class="fixed-state mb15" style="display: none;"></div>
                <div class="btn mr10 mb10 left"><input type="button" onclick="jAutoItemsPromote.submit(this);" value="<?= _t('', 'Оплатить'); ?>" /><i></i></div>
                <div class="clear"></div>
            </form>
            <div class="separator"></div>
        </div>
        <? } ?>

        <? /* VIP */ ?>
        <? if( ! empty($svc['vip']) && ! empty($svc['vip']['on']) ) { $s =& $svc['vip']; ?>
        <h3><a class="ajax bp-block-link" href="#" onclick="return jAutoItemsPromote.selectBlock(this);"><?= _t('', 'VIP объявление'); ?></a></h3>
        <div class="bp-block displaynone">
            <form>
                <input type="hidden" name="svc" value="<?= Auto::SERVICE_VIP ?>" />
                <div class="error mb15" style="display: none;"></div>
                <div class="mb15"><?= $s['description'][LNG] ?></div>
                <? $paySystemsBlock($s['price']); ?>
                <div class="mb15">
                    <?= _t('', 'Стоимость: <b>[price]</b>', array('price'=>$s['price'].' '.$currency)); ?>
                </div>
                <div class="vip-state mb15" style="display: none;"></div>
                <div class="btn mr10 mb10 left"><input type="button" onclick="jAutoItemsPromote.submit(this);" value="<?= _t('', 'Оплатить'); ?>" /><i></i></div>
                <div class="clear"></div>
            </form>
            <div class="separator"></div>
        </div>
        <? } ?>

    </div>

    </div>
</div>